#!/usr/bin/env Rscript

######################################################## READ TRY AND FORMAT DATA CHECK ERROR


################ use AccSpeciesName because not author name

source("../format.data/try.fun.R")

out.dir <- "../../output/formatted/TRY"
dir.create(out.dir, recursive=TRUE,showWarnings=FALSE)

## read TRY data
TRY.DATA <- read.table("../../data/raw/TRY/TRY_Proposal_177_DataRelease_2013_04_01.txt", 
    sep = "\t", header = TRUE, na.strings = "", stringsAsFactors = FALSE)

TRY.DATA2 <- read.table("../../data/raw/TRY/TRY_Proposal_177_DataRelease_2013_07_23.txt", 
    sep = "\t", header = TRUE, na.strings = "", stringsAsFactors = FALSE)

### combine both data set
TRY.DATA <- rbind(TRY.DATA, TRY.DATA2)
rm(TRY.DATA2)
################################## ERROR FOUND IN THE DATA BASE 1 problem with the seed mass of this obs seed mass
################################## = 0 DELETE
TRY.DATA <- TRY.DATA[!(TRY.DATA$ObservationID == 1034196 & TRY.DATA$DataName == "Seed dry mass"), 
    ]
#### IS 'Quercuscrispla sp' an error standing for Quercus crispula synonym of
#### Quercus mongolica subsp. crispula (Blume) Menitsky ? ask Jens
#### TRY.DATA[TRY.DATA$AccSpeciesName=='Quercuscrispla sp' ,]


######################## first create a table with one row per Observation.id and column for each traits
######################## and variable
Non.Trait.Data <- c("Latitude", "Longitude", "Reference", "Date of harvest / measurement", 
    "Altitude", "Mean annual temperature (MAT)", "Mean sum of annual precipitation (PPT)", 
    "Plant developmental status / plant age", "Maximum height reference", "Source in Glopnet", 
    "Number of replicates", "Sun vers. shade leaf qualifier")

Trait.Data <- sort(names(((table(TRY.DATA$TraitName)))))

########################## REFORMAT DATA from TRY
registerDoParallel(cores = 5)  ## affect automaticaly half of the core detected to the foreach here I decide to affect 4 cores
getDoParWorkers()  ## here 8 core so 4 core if want to use more registerDoParallel(cores=6)

TRY.DATA.FORMATED <- foreach(ObservationID.t = unique(TRY.DATA$ObservationID), .combine = rbind) %dopar% 
    {
        fun.extract.try(ObservationID.t, data = TRY.DATA, Non.Trait.Data, Trait.Data)
    }


## head(TRY.DATA.FORMATED) dim(TRY.DATA.FORMATED)

saveRDS(TRY.DATA.FORMATED, file = file.path(out.dir, "TRY.DATA.FORMATED.rds"))

#### TODO MODIFY THE FUNCTION TO KEEP TRAITS SD AND INCLUDE IT LATER ON

######################## READ RDS
TRY.DATA.FORMATED$AccSpeciesName <- as.character(TRY.DATA.FORMATED$AccSpeciesName)

### select only the five traits we will use
traits <- c("StdValue.Leaf.nitrogen..N..content.per.dry.mass", "StdValue.Seed.mass", 
    "StdValue.Leaf.specific.area..SLA.", "StdValue.Stem.specific.density..SSD.", 
    "StdValue.Plant.height.vegetative")
data.TRY.std <- subset(TRY.DATA.FORMATED,select=c("ObservationID","AccSpeciesName","TF.exp.data","Reference","Sun.vers..shade.leaf.qualifier",traits))
names(data.TRY.std) <- c("obs.id","Latin_name","TF.exp.data","Reference","Sun.vs.shade.leaf","Leaf.N", "Seed.mass", "SLA", "Wood.density","height")

saveRDS(data.TRY.std,file= file.path(out.dir, "data.TRY.std.rds"))


#####################################################################
### COMPUTE mean SD species:genus for each traits

######## The table 5 in Kattge et al. 2011 GCB provides estimation of mean species sd
######## SLA species sd log 0.09 Nmass species sd log 0.08 Seed Mass sd log 0.13

## # SEE sd.log.SLA <- 0.09 ### based on Kattge et al. 2011 sd.log.Nmass <- 0.08
## ### based on Kattge et al. 2011 sd.log.Seed.Mass <- 0.13 ### based on Kattge et
## al. 2011 sd.log.LL <- 0.03 ### based on Kattge et al. 2011


###################### Computed sd over the data in log10 we have under the assumption sd constant
###################### over species with lm per species
traits <- c("StdValue.Leaf.nitrogen..N..content.per.dry.mass", "StdValue.Seed.mass", 
    "StdValue.Leaf.specific.area..SLA.", "StdValue.Stem.specific.density..SSD.", 
    "StdValue.Plant.height.vegetative")

## minimum number of observation per species to be incldue
N.min <- 3


########################### SPECIES MEAN SD
sd.vec.sp <- rep(NA, 5)

for (i in 1:(length(traits) - 1)) {
    table.sp.tmp <- table(TRY.DATA.FORMATED[!is.na(TRY.DATA.FORMATED[[traits[i]]]), 
        "AccSpeciesName"])
    data.t <- TRY.DATA.FORMATED[TRY.DATA.FORMATED[["AccSpeciesName"]] %in% names(table.sp.tmp)[table.sp.tmp > 
        N.min], c("AccSpeciesName", traits[i])]
    names(data.t) <- c("sp", "trait")
    lm.obj <- lm(log10(trait) ~ sp, data = data.t)
    print(i)
    sd.vec.sp[i] <- sd(residuals(lm.obj))
}

### compute 99% quantile of height and its sd TODO COMPUTE WITH ONLY SPECIES WITH
### AT LEAST TWO OBSERVATIONS
library(quantreg)
table.sp.tmp <- table(TRY.DATA.FORMATED[!is.na(TRY.DATA.FORMATED[[traits[5]]]), "AccSpeciesName"])
data.t <- TRY.DATA.FORMATED[TRY.DATA.FORMATED[["AccSpeciesName"]] %in% names(table.sp.tmp)[table.sp.tmp > 
    N.min], ]
res.rq <- rq(log10(StdValue.Plant.height.vegetative) ~ AccSpeciesName - 1, tau = 0.99, 
    data = data.t)
summary.res.rq <- summary(res.rq, se = "boot")
sd.vec.sp[5] <- mean(summary.res.rq$coefficients[, "Std. Error"])

## higher than the one reported in Kattge et al. 2011


####################### Computed sd over the data we have under the assumption sd constant over genus
sd.vec.genus <- rep(NA, 5)
for (i in 1:(length(traits) - 1)) {
    table.sp.tmp <- table(sapply(TRY.DATA.FORMATED[!is.na(TRY.DATA.FORMATED[[i]]), 
        "AccSpeciesName"], FUN = fun.get.genus))
    data.t <- TRY.DATA.FORMATED[sapply(TRY.DATA.FORMATED[["AccSpeciesName"]], fun.get.genus) %in% 
        names(table.sp.tmp)[table.sp.tmp > N.min], c("AccSpeciesName", traits[i])]
    names(data.t) <- c("sp", "trait")
    data.t$gs <- sapply(data.t[["sp"]], fun.get.genus)
    lm.obj <- lm(log10(trait) ~ gs, data = data.t)
    sd.vec.genus[i] <- sd(residuals(lm.obj))
}

## quantile for Height with quantreg
table.sp.tmp <- table(sapply(TRY.DATA.FORMATED[!is.na(TRY.DATA.FORMATED[[traits[5]]]), 
    "AccSpeciesName"], FUN = fun.get.genus))
data.t <- TRY.DATA.FORMATED[sapply(TRY.DATA.FORMATED[["AccSpeciesName"]], fun.get.genus) %in% 
    names(table.sp.tmp)[table.sp.tmp > N.min], ]

res.rq <- rq(log10(TRY.DATA.FORMATED$StdValue.Plant.height.vegetative) ~ sapply(TRY.DATA.FORMATED$AccSpeciesName, 
    FUN = fun.get.genus) - 1, tau = 0.99)
summary.res.rq <- summary(res.rq, se = "boot")
sd.vec.genus[5] <- mean(summary.res.rq$coefficients[, "Std. Error"])

##### SET NAME VECTORS

names(sd.vec.sp) <- c("sdlog10.sp.Nmass", "sdlog10.sp.Seed.Mass", "sdlog10.sp.SLA", 
    "sdlog10.sp.WD", "sdlog10.sp.Height")

names(sd.vec.genus) <- c("sdlog10.gs.Nmass", "sdlog10.gs.Seed.Mass", "sdlog10.gs.SLA", 
    "sdlog10.gs.WD", "sdlog10.gs.Height")

## save mean species and genus sd
saveRDS(sd.vec.sp, file =  file.path(out.dir, "sd.vec.sp.rds"))
saveRDS(sd.vec.genus, file =  file.path(out.dir, "sd.vec.genus.rds"))


# ### plot sd to show mark
# pdf(file.path(out.dir, "sd.traits.pdf"))
# r <- barplot(sd.vec.sp, names.arg = c("Leaf.N", "SM", "SLA", "WD", "Vessel", "LL"), 
#     las = 2, ylim = c(0, 0.9), ylab = "sd log10")
# points(r[, 1], sd.vec.genus, col = "red", pch = 16, cex = 2)
# ## for (i in 1:length(nobs.names)){ ## sd.obs <-
# ## data.TRY.sd.update[[sd.names[i]]][!data.TRY.sd.update[[genus.names[i]]]] ##
# ## points(rep(r[i,1],length(sd.obs)),sd.obs) ## sd.obs <-
# ## data.TRY.sd.update[[sd.names[i]]][data.TRY.sd.update[[genus.names[i]]]] ##
# ## points(rep(r[i,1],length(sd.obs)),sd.obs,col='red',pch=4) print(sd.obs) }
# dev.off() 
